<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>
      <q-header elevated>
        <Toolbar :hasBackButton="true" :pageTitle="$t('contacts.page_title')" />
      </q-header>

      <q-page class="pl-fullpage">
        <div class="row">

          <div class="mobile-controls">
            <div :class="[viewingContacts ? 'selectedOption' : 'unselectedOption', 'display-option-header']"
              @click="viewingContacts = true">
              <h6 class="q-my-md" style="text-align: center">
                <q-icon color="primary" name="contact_phone" class="mob-header-icon" />
                {{ $t("contacts.contacts_list_title") }}
              </h6>
            </div>
            <div :class="[viewingContacts ? 'unselectedOption' : 'selectedOption', 'display-option-header']"
              @click="viewingContacts = false">
              <h6 class="q-my-md" style="text-align: center">
                <q-icon color="primary" name="groups" class="mob-header-icon" />
                {{ $t("contacts.groups_list_title") }}
              </h6>
            </div>
          </div>

          <!-- START CONTACTS -->

          <div :class="[{ 'hideOnMobile': !viewingContacts }, 'contacts-section']" v-if="user != null">
            <div class="large-display-header">
              <h6 class="q-my-md" style="text-align: center">
                <q-icon color="primary" name="contact_phone" style="font-size: 2em; padding-right: 10px" />
                {{ $t("contacts.contacts_list_title") }}
              </h6>
            </div>

            <!-- Show button at top of list if it's long to avoid unnecessary scrolling -->
            <div v-if="user.Contacts && Object.keys(contactsExceptCurrentUser).length > 9" class="create-button-wrapper">
              <q-btn color="primary" :label="$t('contacts.add_contact')" icon="add" @click="addContact()" />
            </div>

            <q-list v-if="user != null" separator style="margin-bottom:60px">
              <q-item v-for="(contact, phoneNumber) in contactsExceptCurrentUser || {}" :key="phoneNumber">
                <q-item-section class="contact-details">
                  <q-item-label> {{ contact.Name }} </q-item-label>
                  <q-item-label caption> {{ phoneNumber }} </q-item-label>
                </q-item-section>
                <q-item-section side>
                  <q-btn flat round dense icon="edit" @click="
                    {
                      editingContact = phoneNumber;
                      addingNewContact = true;
                    }
                  " />
                </q-item-section>
                <q-item-section side>
                  <q-btn dense flat round icon="delete" @click="handleDeleteContact(phoneNumber)" />
                </q-item-section>
              </q-item>
              <div v-if="!user.Contacts" class="explanation">
                {{ $t("contacts.contacts_list_empty") }}
                <p style="margin-top: 5px">{{ $t("contacts.contacts_list_expla") }} </p>

                <div class="create-button-wrapper">
                  <q-btn color="primary" :label="$t('contacts.add_contact')" icon="add" @click="addContact()" />
                </div>
              </div>
              <q-btn v-else fab icon="add" round color="primary" style="float:right; margin-top: 10px;"
                @click="addContact()" />
            </q-list>
          </div>

          <!-- END CONTACTS -->

          <!-- START GROUPS  -->

          <div :class="[{ 'hideOnMobile': viewingContacts }, 'groups-section']">

            <div class="large-display-header">
              <h6 class="q-my-md" style="text-align: center">
                <q-icon color="primary" name="groups" style="font-size: 2em; padding-right: 10px" />
                {{ $t("contacts.groups_list_title") }}
              </h6>
            </div>

            <q-list v-if="user != null" separator style="margin-bottom:60px">
              <q-item v-for="(group, id) in user.Groups || {}" :key="id">
                <q-item-section class="contact-details">
                  <q-item-label> {{ group.Name }} </q-item-label>
                  <q-item-label caption v-if="group.Members"> {{ $t("contacts.group_num_members",
                    [Object.keys(group.Members).length])
                  }} </q-item-label>
                </q-item-section>
                <q-item-section side>
                  <q-btn flat round dense icon="edit" class="item-button" @click="addGroup(group)" />
                </q-item-section>
                <q-item-section side>
                  <q-btn dense flat round icon="delete" @click="handleDeleteGroup(group.Name)" />
                </q-item-section>
              </q-item>

              <div v-if="!user.Groups" class="explanation">
                {{ $t("contacts.groups_list_empty") }}
                <p style="margin-top: 5px">{{ $t("contacts.groups_list_expla") }} </p>

                <p v-if="!user.Contacts">
                  {{ $t("contacts.groups_no_contacts") }}
                </p>

                <div class="create-button-wrapper">
                  <q-btn color="primary" :label="$t('contacts.add_group')" icon="add" :disable="user.Contacts == null"
                    @click="addGroup()" />
                </div>
              </div>
              <q-btn v-else fab icon="add" round color="primary" style="float:right; margin-top: 10px;"
                @click="addGroup()" />
            </q-list>
          </div>
        </div>

        <!-- END GROUPS -->
      </q-page>


      <!-- ADD/EDIT CONTACT DIALOGUE -->
      <q-dialog v-model="addingNewContact">
        <q-card class="input-dialog">
          <q-card-section>
            <h6 class="q-my-none">
              {{
                editingContact === undefined
                ? $t("contacts.add_contact")
                : $t("contacts.edit_contact")
              }}
            </h6>
          </q-card-section>
          <q-separator></q-separator>
          <q-card-section>
            <InviteArbitraryNumber v-if="user != null" :usersPhone="user.Phone" :inviteParticipant="handleNewContact"
              :participants="contactsExceptForTheOneBeingEdited"
              :defaultName="((user.Contacts || {})[editingContact] || {}).Name"
              :defaultNumber="parseEditingPhone.nationalNumber" :defaultPhoneCode="
                parseEditingPhone.countryCallingCode == undefined
                  ? defaultPhoneCode
                  : `+${parseEditingPhone.countryCallingCode}`
              " hideModerator :type="editingContact ? 'save' : 'add'" />
          </q-card-section>
        </q-card>
      </q-dialog>

      <!-- END ADD/EDIT CONTACT DIALOGUE -->

      <!-- ADD/EDIT GROUP DIALOGUE -->
      <q-dialog v-model="addingNewGroup" v-if="user != null && editingGroup != null">
        <q-card class="input-dialog group-dialog">
          <q-card-section>
            <h6 class="q-my-none">
              {{
                editingContact === undefined
                ? $t("contacts.add_group")
                : $t("contacts.edit_group")
              }}
            </h6>
          </q-card-section>
          <q-separator></q-separator>
          <q-card-section>
            <q-form ref="formRef" @submit="handleAddGroup" @reset="handleResetGroupForm">
              <q-input :label="$t('required.name')" :rules="[(val) => (val && val.length > 0) || $t('empty.name')]" filled
                v-model="editingGroup.Name" />

              <q-scroll-area class="dialogue-scroll">
                <q-list separator style="margin-bottom:60px">
                  <q-item v-for="(contact, phoneNumber) in contactsExceptCurrentUser || {}" :key="phoneNumber">
                    <q-item-section class="contact-details">
                      <q-item-label> {{ contact.Name }} </q-item-label>
                      <q-item-label caption> {{ phoneNumber }} </q-item-label>
                    </q-item-section>
                    <q-item-section side
                      v-if="editingGroup.Members[phoneNumber] && editingGroup.Members[phoneNumber].Included">
                      <q-checkbox v-model="editingGroup.Members[phoneNumber].Moderator" color="orange" checked-icon="star"
                        unchecked-icon="star_border" />
                    </q-item-section>
                    <q-item-section side v-if="editingGroup.Members[phoneNumber]">
                      <q-checkbox v-model="editingGroup.Members[phoneNumber].Included" />
                    </q-item-section>
                  </q-item>
                </q-list>
              </q-scroll-area>
              <div class="row items-center justify-between">

                <q-space />
                <q-btn type="submit" color="primary" rounded :icon-right="editingExistingGroup ? 'save' : 'add'">
                  {{
                    $t(
                      `invite_arbitrary_number.${editingExistingGroup ? "save_person" : "add_person"
                      }`
                    )
                  }}&nbsp;
                </q-btn>
              </div>
            </q-form>
          </q-card-section>
        </q-card>
      </q-dialog>

      <!-- END ADD/EDIT GROUP DIALOGUE -->

    </q-page-container>
  </q-layout>
</template>
<script>
import InviteArbitraryNumber from "../components/InviteArbitraryNumber";
import { auth, db, functions } from "../firebase";
import { parseNumber } from "../utils/phone"
import Toolbar from "../components/Toolbar.vue";

export default {
  data()
  {
    return {
      addingNewContact: false,
      editingContact: undefined,
      addingNewGroup: false,
      editingExistingGroup: false,
      editingGroup: null,
      user: null,
      viewingContacts: true
    };
  },
  computed: {
    parseEditingPhone()
    {
      return this.editingContact !== undefined
        ? parseNumber(this.editingContact)
        : "";
    },
    defaultPhoneCode()
    {
      return process.env.VUE_APP_DEFAULT_PHONE;
    },
    contactsExceptCurrentUser()
    {
      const contacts = {};
      for (const phoneNumber in this.user.Contacts || {})
      {
        if (phoneNumber !== this.user.Phone)
        {
          contacts[phoneNumber] = { ...this.user.Contacts[phoneNumber] };
        }
      }
      return contacts;
    },
    contactsExceptForTheOneBeingEdited()
    {
      const contacts = {};
      for (const phoneNumber in this.contactsExceptCurrentUser || {})
      {
        if (phoneNumber !== this.editingContact)
        {
          contacts[phoneNumber] = { ...this.user.Contacts[phoneNumber] };
        }
      }
      return contacts;
    },
  },
  methods: {
    addContact()
    {
      this.editingContact = undefined;
      this.addingNewContact = true;
    },
    addGroup(existing = null)
    {
      let blankMembers = {};

      for (const number in this.user.Contacts) 
      {
        // need to populate for the stupid quasar checkboxes to show unticked...
        blankMembers[number] = {
          'Included': false,
          'Moderator': false
        }
      }

      this.editingGroup = {
        'Name': "",
        'Members': blankMembers
      };

      if (existing)
      {
        this.editingGroup.Name = existing.Name;
        this.editingGroup.OriginalName = existing.Name;
        for (const member in existing.Members)
        {
          this.editingGroup.Members[member].Included = true;
          this.editingGroup.Members[member].Moderator = existing.Members[member];
        }
      }

      this.editingExistingGroup = existing != null;
      this.addingNewGroup = true
    },
    async handleDeleteGroup(name)
    {
      this.$q
        .dialog({
          title: this.$t("confirm"),
          message: this.$t("contacts.confirm_delete_group"),
          ok: { label: this.$t("delete"), flat: true, color: "negative" },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
        .onOk(async () =>
        {
          try 
          {
            const delGroupFb = functions.httpsCallable("deleteGroup");

            this.$q.loading.show();
            await delGroupFb(name);
            this.$q.loading.hide();
          }
          catch (error) 
          {
            console.log(error)
            this.$q.loading.hide();
            this.$q.notify({
              type: 'negative',
              message: error
            })
          }
        });


    },
    async handleAddGroup() 
    {
      try 
      {
        // Remove particular special chars so we can use this as RTDB key
        /* eslint-disable no-useless-escape*/
        this.editingGroup.Name = this.editingGroup.Name.replace(/[\[\].#$"/]/g, "");
        /* eslint-enable no-useless-escape*/

        const newGroupName = this.editingGroup.Name.toLowerCase();

        if (!this.editingExistingGroup)
        {
          for (const existingGroup in this.user.Groups)
          {
            if (existingGroup.toLowerCase() == newGroupName)
            {
              this.$q.notify({
                type: 'negative',
                message: this.$t("contacts.group_duplicate")
              })
              return;
            }
          }
        }

        const createGroupFb = functions.httpsCallable("createGroup");

        let finalMembers = {};
        for (const number in this.editingGroup.Members) 
        {
          if (this.editingGroup.Members[number].Included) 
          {
            finalMembers[number] = this.editingGroup.Members[number].Moderator;
          }
        }

        if (!finalMembers || Object.keys(finalMembers).length == 0)
        {
          this.$q.notify({
            type: 'negative',
            message: this.$t("contacts.group_empty")
          })
          return;
        }

        this.$q.loading.show();

        let packet = {
          Name: this.editingGroup.Name,
          Members: finalMembers,
        };

        if (this.editingGroup.OriginalName)
        {
          packet.OriginalName = this.editingGroup.OriginalName;
        }

        await createGroupFb(packet);

        this.$q.loading.hide();

        this.addingNewGroup = false;
        this.editingGroup = null;
      }
      catch (error) 
      {
        console.log(error)
        this.$q.loading.hide();
        this.$q.notify({
          type: 'negative',
          message: error
        })
      }
    },
    async handleResetGroupForm()
    {

    },
    async handleNewContact(phoneNumber, participant)
    {
      const createContactFb = functions.httpsCallable("createContact");
      this.$q.loading.show();
      await createContactFb({
        Name: participant.Name,
        Number: phoneNumber,
      });
      this.$q.loading.hide();
      if (this.editingContact && this.editingContact !== phoneNumber)
      {
        const deleteContactFb = functions.httpsCallable("deleteContact");
        await deleteContactFb(this.editingContact);
      }
      this.addingNewContact = false;
      this.editingContact = undefined;
    },
    handleDeleteContact(phoneNumber)
    {
      this.$q
        .dialog({
          title: this.$t("confirm"),
          message: this.$t("contacts.confirm_delete_contact"),
          ok: { label: this.$t("delete"), flat: true, color: "negative" },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
        .onOk(async () =>
        {
          this.$q.loading.show();
          const deleteContactFb = functions.httpsCallable("deleteContact");
          const response = await deleteContactFb(phoneNumber);
          console.log(response);
          this.$forceUpdate();
          this.$q.loading.hide();
        });
    },
  },
  created()
  {
    this.$rtdbBind("user", db.ref(`Users/${auth.currentUser.uid}`)).then(
      (val) => console.log(val.val())
    );
  },
  components: {
    InviteArbitraryNumber,
    Toolbar
  },
};
</script>

<style scoped>
.row {
  display: flex;
  align-items: stretch;
}

.contacts-section {
  vertical-align: top;
  flex: 1;
  width: 50%;
  margin: 0 auto;
  text-align: left;
  padding-right: 10px;
  display: inline-block;
}

.groups-section {
  vertical-align: top;
  top: 0;
  flex: 1;
  width: 50%;
  margin: 0 auto;
  text-align: left;
  padding-left: 10px;
  display: inline-block;
}

.explanation {
  text-align: center;
  margin-bottom: 20px;
  padding-left: 10px;
  padding-right: 10px;
}

.input-dialog {
  min-width: 50%;
}

.create-button-wrapper {
  width: 100%;
  text-align: center;
  margin: 10px 0px;
}

.q-btn-item {
  margin-top: 5px;
  font-size: 0.8em;
}

.dialogue-scroll {
  height: 300px;
  margin: 10px;
}

.group-dialog {
  width: 550px;
}

.mobile-controls {
  display: none;
}

.selectedOption {
  border: 3px;
  border-style: solid;
  border-color: var(--q-color-primary);
}

.unselectedOption {
  border: 3px;
  border-style: solid;
  border-color: gainsboro;
}

.mob-header-icon {
  font-size: 1.3em;
  padding-right: 10px
}

@media only screen and (min-width: 1150px) {
  .input-dialog {
    min-width: unset;
    width: 550px;
  }

}

@media only screen and (max-width: 800px) {

  .mobile-controls {
    display: block;
    margin-bottom: 20px;
  }

  .display-option-header {
    width: 50%;
    display: inline-block;
  }

  .large-display-header {
    display: none;
  }

  .hideOnMobile {
    display: none;
  }

  .row {
    display: block;
    text-align: center;
  }

  .contact-details {
    float: left;
    text-align: left;
    vertical-align: auto;
  }

  .contacts-section {
    width: 410px;
    margin: auto;
  }

  .groups-section {
    width: 410px;
    margin-top: 20px;
  }

  .q-btn-item {
    font-size: 1em;
  }
}

@media only screen and (max-width: 900px) {

  .group-dialog {
    min-width: 70%;
  }
}

@media only screen and (max-width: 720px) {

  .group-dialog {
    min-width: 90%;
  }
}

@media only screen and (max-width: 500px) {

  .contacts-section,
  .groups-section {
    width: 100%;
    padding: 0 20px;
  }
}

@media only screen and (max-width: 400px) {

  .contacts-section,
  .groups-section {
    width: 100%;
    padding: 0 20px;
  }

  .mob-header-icon {
    font-size: 1.1em;
    padding-right: 10px
  }

  .mobile-controls h6 {
    font-size: 1rem;
  }
}
</style>
